image: busybox:latest

cache:
  key:
    files:
      - composer.lock
  paths:
    - vendor/

stages:
  - build
  - test
  - deploy
  - stop

variables:
  IMAGE_TAG: $CI_COMMIT_BRANCH-$CI_COMMIT_SHORT_SHA

before_script:
  - echo "Before script section"
  - echo "For example you might run an update here or install a build dependency"
  - echo "Or perhaps you might print out some debugging details"

after_script:
  - echo "After script section"
  - echo "For example you might do some cleanup here"


build1:
  stage: build
  script:
    - mkdir -p vendor/
    - echo "build" > vendor/hello.txt

test1:
  stage: test
  resource_group: phone  
  script:
    - cat vendor/hello.txt
    - sleep 300

deploy to stage:
  stage: deploy
  variables:
    TARGET_ENV: staging
  script:
    - echo "Do your deploy here to ${TARGET_ENV} ENV ${MY_ENV}"
  only:
    - master
  environment:
    name: staging
    on_stop: stop to staging
    auto_stop_in: 1 day


stop to staging:
  stage: stop
  variables:
    TARGET_ENV: staging
  script:
    - echo "STOP ${TARGET_ENV}"
  only:
    - master
  when: manual
  environment:
    name: staging
    action: stop

deploy to prod:
  stage: deploy
  variables:
    TARGET_ENV: prod
  script:
    - echo "Do your deploy here to ${TARGET_ENV} ENV ${MY_ENV}"
  only:
    - master
  when: manual
  environment:
    name: prod
    on_stop: stop to prod

stop to prod:
  stage: stop
  variables:
    TARGET_ENV: prod
  script:
    - echo "STOP ${TARGET_ENV}"
  only:
    - master
  when: manual
  environment:
    name: prod
    action: stop
